routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Genre;
use App\Http\Resources\GenreResource;
use App\Http\Resources\SerieResource;
use App\Serie;

Auth::routes();

Route::get('/', 'MainController@index')->name('home');
Route::get('/home', 'MainController@index')->name('home');
Route::resource('episodes', 'EpisodeController');
Route::resource('comments', 'CommentController');

Route::resource('genres', 'GenreController');
Route::resource('series', 'SerieController');

Route::get('modifier_avis_redaction/{id}','SerieController@editAvis')->name("editAvis");
Route::resource('users', 'UserController');

Route::get('/saison/{idSerie}/{idSaison}','SerieController@showSaison')->name('showSaison');

app/Comment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Comment extends Model
{
    // A comment is written by an user
    public function utilisateur() {
        return $this->belongsTo("App\User", "user_id");
    }

    // A comment is dedicated to a serie
    public function serie() {
        return $this->belongsTo("App\Serie", "serie_id");
    }
}

app/Http/Controllers/CommentController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Policies\CommentPolicy;
use App\Providers\AuthServiceProvider;
use App\Serie;
use App\User;
use Illuminate\Contracts\Auth\Access\Gate;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Cookie;

class CommentController extends Controller
{

    public function index(Request $request) {
        $cat = $request->query('cat', '');
        $value = $request->cookie('cat');
        if ($cat == 'All' || (empty($cat) && empty($value))) {
            if (empty($cat))
                $cat = 'All';
            else
                Cookie::queue('cat', '', 0, '/comments');
            $comments = Comment::all();
        } elseif (!empty($cat) || !empty($value)) {
            if (empty($cat))
                $cat = $value;
            $comments = Comment::where('serie_id', $cat)->get();
            Cookie::queue('cat', $cat, 10, '/comments');
        }

        $series_id = Comment::distinct('series_id')->pluck('serie_id');
        return view('comments.index', ['comments' => $comments, 'cat' => $cat, 'series_id' => $series_id]);
    }


    public function create()
    {
        return view('comments.create');
    }


    public function store(Request $request)
    {
        // validation des données de la requête
        $this->validate(
            $request,
            [
                'content' => 'required',
                'note' => 'required',
            ]
        );

        // code exécuté uniquement si les données sont validées
        // sinon un message d'erreur est renvoyé vers l'utilisateur

        // préparation de l'enregistrement à stocker dans la base de données
        $comment = new Comment;

        $comment->content = $request->get("content");
        $comment->note = $request->note;
        $comment->validated = 1;
        $comment->user_id = 1;
        $comment->serie_id=$request->serie_id;


        // insertion de l'enregistrement dans la base de données
        $comment->save();

        // redirection vers la page qui affiche la liste des comments
        return redirect('/comments?cat='.$comment->serie_id);
    }


    public function show(Request $request, $id) {
        $action = $request->query('action', 'show');
        $comment = Comment::find($id);
        $serie = Serie::find($comment->serie_id);
        return view('comments.show', ['comment' => $comment, 'action' => $action,'serie'=>$serie]);
    }

    public function edit($id)
    {
        $comment = Comment::find($id);
        return view('comments.edit', ['comment' => $comment]);
    }

    public function update(Request $request, $id) {
        $comment = Comment::findOrFail($id);

        /*if ($this -> $user->cant('update', $comment)) {
            return redirect()->route('serie.show', ['jeu' => $comment->serie, 'action' => 'show'])->with('status', 'Impossible de modifier le commentaire');
        }*/

        $this->validate(
            $request, [
                'content' => 'required',
                'note' => 'required',
                ]
        );

        $comment->content = $request->get("content");
        $comment->note = $request->note;
        $comment->validated = 1;
        $comment->user_id = 1;
        $comment->serie_id;



        $comment->save();

        return redirect()->route('series.show', ['serie' => $comment->serie, 'action' => 'show'])->with('status', 'Commentaire modifié avec succès');
    }

    public function destroy(Request $request, $id) {
        $comment = Comment::findOrFail($id);
        //$this->authorize('delete', $comment);

        if ($request->delete == 'delete') {
            $comment->delete();
        }

        else if($request->modify == 'modify') {
           return redirect()->route("comments.edit",$comment->id);
        }

        return redirect('/comments?cat='.$comment->serie_id);
    }
}

resources/views/comments/create.blade.php
@extends('layouts.app')

@section('content')

{{--
   messages d'erreurs dans la saisie du formulaire.
--}}


@if ($errors->any())
    <div>
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif
{{--
     formulaire de saisie d'un commentaire
     la fonction 'route' utilise un nom de route
     'csrf_field' ajoute un champ caché qui permet de vérifier
       que le formulaire vient du serveur.
  --}}

<form action="{{route('comments.store')}}" method="POST">
    @csrf
    <div class="text-center" style="margin-top: 2rem">
        <h3>Création d'un commentaire</h3>
        <hr class="mt-2 mb-2">

    </div>
        {{-- content --}}
    <label for="content"><strong>Contenu: </strong></label>
    <textarea type="text" id="content" rows = "2" name="content" class="form-control"> {{ old('content') }}
    </textarea>
    <div>

        {{-- note --}}
        <label for="note"><strong>Note (/10) : </strong></label>
        <input type="integer" id="note" name="note">
    </div>

    <div>
        <button class="btn btn-success" type="submit">Valide</button>
    </div>
</form>

@endsection

resources/views/comments/edit.blade.php
@extends('layouts.app')

@section('content')
    {{--
   messages d'erreurs dans la saisie du formulaire.
--}}

@if ($errors->any())
    <div>
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif
{{--
     formulaire de saisie d'un commentaire
     la fonction 'route' utilise un nom de route.
     '@csrf' ajoute un champ caché qui permet de vérifier
       que le formulaire vient du serveur.
     '@method('PUT') précise à Laravel que la requête doit être traitée
      avec une commande PUT du protocole HTTP.
  --}}

<form action="{{route('comments.update',$comment->id)}}" method="POST">
    @csrf
    @method('PUT')
    <div class="text-center" style="margin-top: 2rem">
        <h3>Modification d'un commentaire</h3>
        <hr class="mt-2 mb-2">
    </div>


    <div>

        {{-- content --}}
    <label for="content"><strong>Contenu : </strong></label>
    <textarea type="text" id="content" rows = "2" name="content" class="form-control"> {{ old('content') }}
    </textarea>
    </div>
    <div>

        {{-- note --}}
        <label for="note"><strong>Note : </strong></label>
        <input type="integer" id="note" name="note" value="{{$comment->note}}">
    </div>


    <div>
        <button class="btn btn-success" type="submit" value="valide">Valide</button>
    </div>


</form>
@endsection

resources/views/comments/index.blade.php
@extends('layouts.app')

@section('content')


@if(!empty($comments))
    <h3 class="titre1">Filtrage par catégorie</h3>
    <div class="information-contenu">

        <form action="{{route('comments.index')}}" method="get">
            <label>
                <select name="cat">
                    <option value="All" @if($cat == 'All') selected @endif></option>
                    @foreach($series_id as $serie_id)
                        <option value="{{$serie_id}}"  @if($cat == $serie_id) selected @endif>{{$serie_id}}</option>
                    @endforeach
                </select>
            </label>
            <input type="submit" value="OK">
        </form>
    </div>
    <ul class="liste links">
        @foreach($comments as $comment)
            <br>
            <li><a href="{{route('comments.show', $comment->id)}}"> {{$comment->content}} <b>{{$comment->note}}/10</b></a></li>
        @endforeach
    </ul>
@else
    <h3>Aucun commentaire</h3>
@endif

@endsection

resources/views/comments/show.blade.php
@extends('layouts.app')

@section('content')

<h2 class="titre1">{{$serie->nom}}</h2>
<div class="information-contenu">
    {{-- Content --}}
    <p><strong>Contenu  : </strong>{{$comment->content}}</p>
</div>

<div class="information-contenu">
    {{-- Note --}}
    <b class="note"><strong>Note : </strong>{{$comment->note}}</b>
</div>


@guest
@else
    @if(Auth::id()==$comment->user_id or Auth::user()->administrateur==true)

        <div class="information-contenu">

            <form action="{{route('comments.destroy',$comment->id)}}" method="POST">
                @csrf
                @method('DELETE')
                <div class="text-center">
                    <button type="submit" name="modify" value="modify">Modifier</button>
                    <button type="submit" name="delete" value="delete">Supprimer</button>
                    <button type="submit" name="back" value="back">Retour</button>
                </div>
            </form>

        </div>
    @endif
@endguest

@endsection